Loading...
Searching...
No Matches
nviz.c File Reference

Nviz library – Data management. More...

`#include <grass/colors.h>`
`#include <grass/raster.h>`
`#include <grass/glocale.h>`
`#include <grass/nviz.h>`
Include dependency graph for nviz.c:

Go to the source code of this file.

## Functions

void | Nviz_init_data (nv_data *data)
| Initialize Nviz data.
void | Nviz_destroy_data (nv_data *data)
| Free allocated space by nv_data struct.
void | Nviz_set_bgcolor (nv_data *data, int color)
| Set background color.
int | Nviz_get_bgcolor (nv_data *data)
| Get background color.
int | Nviz_color_from_str (const char *color_str)
| Get color value from color string (name or RGB triplet).
struct fringe_data * | Nviz_new_fringe (nv_data *data, int id, unsigned long color, double elev, int nw, int ne, int sw, int se)
struct fringe_data * | Nviz_set_fringe (nv_data *data, int id, unsigned long color, double elev, int nw, int ne, int sw, int se)
void | Nviz_draw_fringe (nv_data *data)
int | Nviz_set_arrow (nv_data *data, int sx, int sy, float size, unsigned int color)
| Sets the North Arrow position and return world coords.
int | Nviz_draw_arrow (nv_data *data)
| Draws the North Arrow.
void | Nviz_delete_arrow (nv_data *data)
| Deletes the North Arrow.
struct scalebar_data * | Nviz_new_scalebar (nv_data *data, int bar_id, float *coords, float size, unsigned int color)
struct scalebar_data * | Nviz_set_scalebar (nv_data *data, int bar_id, int sx, int sy, float size, unsigned int color)
| Sets the scale bar position and return world coords.
void | Nviz_draw_scalebar (nv_data *data)
| Draws the Scale bar.
void | Nviz_delete_scalebar (nv_data *data, int bar_id)
| Deletes scale bar.

## Detailed Description

Nviz library – Data management.

Based on visualization/nviz/src/

(C) 2008, 2010 by the GRASS Development Team This program is free software under the GNU General Public License (>=v2). Read the file COPYING that comes with GRASS for details.

Author
  Updated/modified by Martin Landa <landa.martin gmail.com> (Google SoC 2008/2010)

Definition in file nviz.c.

## Function Documentation

## Nviz_color_from_str()

int Nviz_color_from_str | ( | const char * | color_str | ) |

Get color value from color string (name or RGB triplet).

Parameters

  color_str | color string

Returns
  color value

Definition at line 125 of file nviz.c.

References BLU_MASK, G_str_to_color(), G_warning(), GRN_MASK, and RED_MASK.

## Nviz_delete_arrow()

void Nviz_delete_arrow | ( | nv_data * | data | ) |

Deletes the North Arrow.

Parameters

  data | nviz data

Definition at line 315 of file nviz.c.

## Nviz_delete_scalebar()

void Nviz_delete_scalebar | ( | nv_data * | data,
|  | int | bar_id )

Deletes scale bar.

When scalebar is freed, array then contains NULL, which must be tested during drawing.

Parameters

  data | nviz data

Definition at line 435 of file nviz.c.

References G_free(), and NULL.

## Nviz_destroy_data()

void Nviz_destroy_data | ( | nv_data * | data | ) |

Free allocated space by nv_data struct.

Parameters

  data | nviz data

Definition at line 68 of file nviz.c.

References G_free(), and NULL.

## Nviz_draw_arrow()

int Nviz_draw_arrow | ( | nv_data * | data | ) |

Draws the North Arrow.

Parameters

  data | nviz data

Definition at line 298 of file nviz.c.

References gsd_north_arrow().

## Nviz_draw_fringe()

void Nviz_draw_fringe | ( | nv_data * | data | ) |

Draw fringe

Parameters

  data | nviz data

Definition at line 234 of file nviz.c.

References GS_draw_fringe().

## Nviz_draw_scalebar()

void Nviz_draw_scalebar | ( | nv_data * | data | ) |

Draws the Scale bar.

Parameters

  data | nviz data

Definition at line 412 of file nviz.c.

References gsd_scalebar_v2().

## Nviz_get_bgcolor()

int Nviz_get_bgcolor | ( | nv_data * | data | ) |

Get background color.

Parameters

  data | nviz data

Returns
  color color value

Definition at line 113 of file nviz.c.

## Nviz_init_data()

void Nviz_init_data | ( | nv_data * | data | ) |

Initialize Nviz data.

Parameters

  data | nviz data

Definition at line 26 of file nviz.c.

References GS_set_light_reset(), NULL, Nviz_new_cplane(), Nviz_new_light(), and Nviz_off_cplane().

## Nviz_new_fringe()

struct fringe_data * Nviz_new_fringe | ( | nv_data * | data,
|  | int | id,
|  | unsigned long | color,
|  | double | elev,
|  | int | nw,
|  | int | ne,
|  | int | sw,
|  | int | se )

Add new fringe

Parameters

  data | nviz data
  id | surface id
  color | color
  elev | fringe elevation
  nw,ne,sw,se | 1 (turn on) 0 (turn off)

Returns
  pointer to allocated fringe_data structure
  NULL on error

Definition at line 150 of file nviz.c.

References G_free(), GS_get_surf_list(), GS_surf_exists(), and NULL.

Referenced by Nviz_set_fringe().

## Nviz_new_scalebar()

struct scalebar_data * Nviz_new_scalebar | ( | nv_data * | data,
|  | int | bar_id,
|  | float * | coords,
|  | float | size,
|  | unsigned int | color )

Add new scalebar

Parameters

  data | nviz data
  bar_id | scale bar id
  coords | real(?) coordinates
  size | scale bar length
  color | scalebar/text color

Returns
  pointer to allocated scalebar_data structure
  NULL on error

Definition at line 333 of file nviz.c.

Referenced by Nviz_set_scalebar().

## Nviz_set_arrow()

int Nviz_set_arrow | ( | nv_data * | data,
|  | int | sx,
|  | int | sy,
|  | float | size,
|  | unsigned int | color )

Sets the North Arrow position and return world coords.

Parameters

  data | nviz data
  sx,sy | screen coordinates
  size | arrow length
  color | arrow/text color

Definition at line 253 of file nviz.c.

References G_free(), GS_get_surf_list(), GS_num_surfs(), and GS_set_Narrow().

## Nviz_set_bgcolor()

void Nviz_set_bgcolor | ( | nv_data * | data,
|  | int | color )

Set background color.

Parameters

  data | nviz data
  color | color value

Definition at line 99 of file nviz.c.

## Nviz_set_fringe()

struct fringe_data * Nviz_set_fringe | ( | nv_data * | data,
|  | int | id,
|  | unsigned long | color,
|  | double | elev,
|  | int | nw,
|  | int | ne,
|  | int | sw,
|  | int | se )

Set fringe

Parameters

  data | nviz data
  id | surface id
  color | color
  elev | fringe elevation
  nw,ne,sw,se | 1 (turn on) 0 (turn off)

Returns
  pointer to allocated fringe_data structure
  NULL on error

Definition at line 194 of file nviz.c.

References G_free(), GS_get_surf_list(), GS_surf_exists(), NULL, and Nviz_new_fringe().

## Nviz_set_scalebar()

struct scalebar_data * Nviz_set_scalebar | ( | nv_data * | data,
|  | int | bar_id,
|  | int | sx,
|  | int | sy,
|  | float | size,
|  | unsigned int | color )

Sets the scale bar position and return world coords.

Parameters

  data | nviz data
  bar_id | scale bar id
  sx,sy | screen coordinates
  size | scale bar length
  color | scalebar/text color

Returns
  pointer to allocated scalebar_data structure
  NULL when there's no surface

Definition at line 367 of file nviz.c.

References G_free(), GS_get_surf_list(), GS_num_surfs(), GS_set_Narrow(), NULL, and Nviz_new_scalebar().